<rss version='2.0' xmlns:atom='http://www.w3.org/2005/Atom'>
	<channel>
		<title>MAIN.LV</title>
		<link>http://main.lv/</link>
		<description>by main.lv</description>
		<language>en-en</language>
		<pubDate>Fri, 28 Sep 2012 18:07:20 GMT</pubDate>
		<atom:link href='http://main.lv/rss.xml' rel='self' type='application/rss+xml' />
		<generator>mainlv_distribution_framework</generator>
		<managingEditor>d.o.s.2.1.h+site@gmail.com</managingEditor>
		<webMaster>d.o.s.2.1.h+site@gmail.com</webMaster>
		
		
		<item>
			<title>GDB helper functions</title>
			<link>http://main.lv/writeup/gdb_helper_functions.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/gdb_helper_functions.html</guid>
			<pubDate>[2015, 6, 22] </pubDate>
			<description>
&lt;pre&gt;
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                              GDB helper functions                            +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                    INDEX                                     +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1. Intro
2. Source
3. First run
4. Breakpoints
5. Registers
6. Helper commands
7. ToDo
8. Links


++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                     1.Intro                                  +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


GDB is GNU debugger. It comes as standard tool in gcc toolchain and all distros 
have it as package. It work on all arch&apos;es that gcc supports and it also can be 
used as remote debugger. To debug it uses Linux kernel debugging functionality 
of ptrace. For first moment its quite confusing tool too many command to type 
and it doesn&apos;t have GUI or TUI. 

What here will be added is command to show XMM registers, general purpose 
registers and eflags with one command. This command make gdb more fun tool
to use. 

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                    2.Source                                  +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


You can find GDB source here http://ftp.gnu.org/gnu/gdb/

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                   3.First run                                +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


For first run we have example of program that just prints some string and
that&apos;s all. If you just run program with debugger and you haven&apos;t given commands
to debugger it will run program as expected if everything is OK with program. 

SOURCE: main1.c

#include &lt;stdio.h&gt;

{	
	printf(&quot;Works fine\n&quot;);
}
 	
 
 

Firs run is 
	
	gdb ./main1

then in gdb command line type

	(gdb) run

And it will show 

	Starting program: main1
	Works fine
	[Inferior 1 (process XXX) exit normally]

String &quot;Works fine&quot; comes from printf&apos;s. And as everything was alright with
program its terminated &quot;normally&quot;. Lets start to go deeper in debugging things.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                  4.Breakpoints                               +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Now lets use break points first breakpoint when to see whats happens in 
program is set at main/_start function of C program as its start point
of program. If program is written in assembler then there could be no
main function like in C but still there entry point to program. And 
possible why how to get address of entry point(main/_start) to program is
with readelf utility

	&gt;readelf -h ./main1 | grep Entry

    Entry point address:               0x400410

Setting breakpoint to main function first way is just

	&gt;gdb ./main1
	(gdb)break main
	Breakpoint 1 at 0x40050a
	(gdb)run
	Start program: ./main1
	Breakpoint 1, 0x040050a in main()

Now we called C main function and stopped at needed location.
Entry point is different in C it could be settuped directly with address or
	
	(gdb) break _start

breakpoint on address

	(gdb) break *0x400410



++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                   5.Registers                                +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Moment when you need debugger is when something &quot;broken&quot; here is example
situation of broken code.

SOURCE: main2.c

int main()
{ 
	int i;

	i = i/0;
}

Run until it break and see what happened
	
	gdb ./main2
	(gdb) run
	Program received signal SIGFPE
	(gdb) display/i $pc
	=&gt; 0x4004c3 &lt;main+13&gt;:  idiv   %ecx


when number is divided on zero CPU usually generates exception and stops
program showing that something bad is happened. 


++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                6.Helper commands                             +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


To improve your experience there could be written macroses that can improve
your experience with gdb. There is example of gdb macroses that could be useful
and if you want to use them you can put gdbalias file at same directory as 
debugged file and load from gdb with
	
	(gdb)source gdbalias

shr32        - show 32 bit general purpose registers
shr32a       - show 32 bit registers with 16, 8 bit registers and system registers
shr64        - show 64 bit general purpose registers
shr64a       - show 64 bit registers and 32/16/8 bit equivalents
shsse_float  - show xmm registers and its 4  32 bit float values
shsse_double - show xmm registers and its 2  64 bit double values
shsse_i8     - show xmm registers and its 16  8 bit integer values
shsse_i16    - show xmm registers and its 8  16 bit integer values
shsse_i32    - show xmm registers and its 4  32 bit integer values
shsse_i64    - show xmm registers and its 2  64 bit integer values
s            - one step in debugger
flags        - show eflags
showrchanges - on every step show changes from previous step
sc           - one step and show changed registers

All register could be printed with gdb command 

	printf

registers name that are used is $rax, $eax, $ax, $ah, $al and all others

shsee commands are showing xmm0 registers and what is inside depends
on you interpretation that why there is 8 registers

	$xmm0,$xmm1,$xmm2,$xmm3,$xmm4,$xmm5,$xmm6,$xmm7

and values depended on interpretation can be accessed as 

X - register index, Y - array index

	$xmmX.v4_float[0]
	$xmmX.v2_double[0]
	$xmmX.v16_int8[0]
	$xmmX.v8_int16[0]
	$xmmX.v4_int32[0]
	$xmmX.v2_int64[0]h

Changes on each step are made just by saving registers:

	set $oldrax = $rax

and when changes happens if/else:

	if ($rax != $oldrax)
		printf &quot;RAX:0x016lX &quot;, $rax
	end

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                     7.ToDo                                   +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Add more descriptions and more basic topics how to use gdb

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                     8.Links                                  +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

[1] http://ftp.gnu.org/gnu/gdb/
[2] https://en.wikipedia.org/wiki/GNU_Debugger
[3] https://github.com/gdbinit/Gdbinit/blob/master/gdbinit
[4] https://sourceware.org/gdb/onlinedocs/gdb/Define.html
[5] https://github.com/FreeArtMan/gdbalias
[6] http://www.delorie.com/gnu/docs/gdb/gdb_28.html
[7] http://www.delorie.com/gnu/docs/gdb/gdb_29.html
&lt;/pre&gt;

</description>
		</item>
		
		<item>
			<title>ASCIITex ascii text formating utility</title>
			<link>http://main.lv/writeup/asciitex_ascii_text_formating_utility.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/asciitex_ascii_text_formating_utility.html</guid>
			<pubDate>[2014, 11, 5] </pubDate>
			<description>ASCIITex is attempt to write tool that formats text to ascii style.
Format width to 80 char width add some title generation and support of RFC
is planned in future. With this tool should be possible to generate
e-zines ;].

&lt;b&gt;Use:&lt;/b&gt;
Minimal features and its usuable for real world ascii text.


&lt;pre class=&quot;brush: bash&quot;&gt;
./asciitex file.at file.txt
&lt;/pre&gt;

</description>
		</item>
		
		<item>
			<title>MicroBBS minimalistic BBS system</title>
			<link>http://main.lv/writeup/microbbs_minimalistic_bbs_system.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/microbbs_minimalistic_bbs_system.html</guid>
			<pubDate>[2014, 11, 5] </pubDate>
			<description>&lt;pre&gt;

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                    MicroBBS                                  +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                    INDEX                                     +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1. Intro
 2. Goal
 3. Usage

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                     1.Intro                                  +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


MicroBBS is attempt to write basic plain BBS that could be run on Linux/BSD 
systems on any kind of hardware. Also minimal dependencies should be used. No 
scripting, no databases, no external libraries as dependencies. Everything 
should be self-sufficient and easyly compiled and lunched.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                     2.Goal                                   +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

basic chat
article publishing
file sharing
message board
maybe door-games

No extra stuff and extra super mega features. Also i have downloaded
old BBS sources and try to write everything in old school style =). Now
its is only 14kb and 50 more kb to go. And yes i will try not to go over
64kb size of executable.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                     3.Usage                                  +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Not alot works now just some picture shows and one article could be readed.
Its still in alfa stage.

Type in shell:

microbbs

And bbs should run in your terminal. You can put it as default shell for ssh

&lt;/pre&gt;

</description>
		</item>
		
		<item>
			<title>RTLSDR usage</title>
			<link>http://main.lv/writeup/rtlsdr_usage.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/rtlsdr_usage.html</guid>
			<pubDate>[2014, 11, 5] </pubDate>
			<description>
&lt;pre&gt;
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                RTLSDR usage                                  +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                    INDEX                                     +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1. Setup rtlsdr
   1.1. Get sources
   1.2. Drivers
   1.3. Check if works
 2. Collection of tools
   2.1. FM
   2.2. Spectrum diagram
   2.3. ADSB
   2.4. AFSK1200
 3. Projects where rtlsdr used
   3.1. WebSDR
 4. Problems
   4.1. Sync errors
 5. Links
 6. Changelog


++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                               1.Setup rtlsdr                                 +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

By rtlsdr usually call RTL2832U chip based tv-tunners which
can be used for not just recievin DVB-T frequencies but much more
and yes price is ~$10 it mean that anyone can just buy and try
without &quot;loosing&quot; money.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1.1.Get sources


Main development repository is on http://sdr.osmocom.org/trac/wiki/rtl-sdr
on github you can find more repos with experminental 
features (https://github.com/keenerd/rtl-sdr).

Getting sources from git:
  git clone git://git.osmocom.org/rtl-sdr.git

I prefer using plain binaries without any kind of installation. Just
compile and use binary without any troubles.
Build:
  cmake .
  make

All binaries is in src dir


++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1.2.Drivers


Linux kernel have some drivers for rtlsdr stick and DVB-T. When you will plug
rtlsdr then kernel probably will load DVB-T drivers and you will not able
to use you rtlsdr for sdr. Way yo fix is it add some drivers to black list and
next time when you will plug rtlsdr this drivers will not be loaded.

Check if rtlsdr related drivers is loaded:
  lsmod | grep rtl28

If there is some drivers then balcklist driver by creating file
in /etc/modprobe.d/ with content:
  blacklist dvb_usb_rtl28xxu

Next thing that could appear is permissions on rtlsdr usage when its pluged in.
To allow everyone to use create file in /etc/udev/rules.d/ with content:
  SUBSYSTEM==&quot;usb&quot;, ATTRS{idVendor}==&quot;0bda&quot;, ATTRS{idProduct}==&quot;2838&quot;, \
  GROUP=&quot;adm&quot;, MODE=&quot;0666&quot;, SYMLINK+=&quot;rtl_sdr&quot;

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1.3.Check if works

How to test if rtlsdr works? Run one of commands:
  rtl_test

I like to run rtl_adsb as you can see there that something is recieved and
you see that everything &quot;works&quot;:
  rtl_adsb

There should be line by line showing up some &quot;hex&quot; lines. If some data is showen
then adsb data from plains is recieved.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                            2.Collection of tools                             +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
2.1.FM

Get some sound trancmited from FM radio stations.

  rtl_fm -f 96.3e6 -M wbfm -s 200000 -r 48000 - | aplay -r 48k -f S16_LE


++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
2.2.Spectrum diagram

Scan spectrum to find some activities on different frequencies.
Good link with all description is http://kmkeen.com/rtl-power/ . 
Main usage of rtl_power is :

  rtl_power -f 76M:108M:125k -i 1 fm_stations.csv

and then draw image :

  heatmap.py fm_stations.csv fm_stations.png

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
2.3.ADSB

ADS-B ( Automatic dependent surveillance broadcast ) in simple words airplain
geoposition, speed, height and flight number broadcasting. You can recieve
this data and see how many plains is around and sometimes flight number.

rtlsdr have default one rtl_adsb programm but it shows only recieved data,
without any decoding. Here is dump1090 specifically for rtlsdr and nothing
more:

  https://github.com/antirez/dump1090

description howto install could be found also here

  http://www.satsignal.eu/raspberry-pi/dump1090.html

Using in interactive mode with height in metrs:
  
  dump1090 --interactive --metric

Output:

  Hex    Flight   Altitude  Speed   Lat       Lon       Track  Messages Seen .  
  ------------------------------------------------------------------------------
  71be01          10052     1009    36.434    33.544    45    9         1 sec
  424913 SDM6329  10966     711     36.440    33.405    221   65        0 sec


++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
2.4.AFSK1200

Gqrx is graphical SDR software where you can travel across frequencies
and in real time search for some transmission.

  http://gqrx.dk/

It have builtin AFSK1200 demodulator or in simple words ham radio packets.
And you could try to see what people sending in tex around the world.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                        3.Projects where rtlsdr used                          +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
3.1.WebSDR

WebSDR probably best site where you can go and click on some radio reciever 
and liste what happends in some particular country. WebSDR site contains
about 80 radio recievers around the world that can be accessed trought web
interface. 
  http://websdr.org/

If you whant setup your own radio reciever read FAQ, prepare mail and send mail
after that you could recieve precompiled websdr software with is easy
to setup with rtlsdr stick.


++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                 4.Problems                                   +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
4.1.Sync errors

Once there was sync error when was trying to use rtl_test or rtl_adsb.
To fix that changes for better quality usb cable.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                   5.Links                                    +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
[1] http://kmkeen.com/rtl-demod-guide/
[2] http://kmkeen.com/rtl-power/
[3] http://sdr.osmocom.org/trac/wiki/rtl-sdr
[4] http://www.rtl-sdr.com/
[5] https://github.com/antirez/dump1090
[6] http://gqrx.dk


++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                 6.Changelog                                  +
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
24aug2014   just initial writeup
5nov2014    prerealese
&lt;/pre&gt;

</description>
		</item>
		
		<item>
			<title>C C11 standart _Generic keyword</title>
			<link>http://main.lv/writeup/c_c11_standart__generic_keyword.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/c_c11_standart__generic_keyword.html</guid>
			<pubDate>[2014, 7, 26] </pubDate>
			<description>&lt;h2&gt;INTRO&lt;/h2&gt;

        In C standart c11 is supported new keyword _Generic. It add way how 
we can add at macro level decisitions about variable types. And now is 
possible make some C++ like function &quot;overloading&quot;. Here is some variants how
to use this generic &quot;_Generic&quot;. Now could print variables dont looking
on its type _Generic will deal with it. 


&lt;h2&gt;EXAMPLES&lt;/h2&gt;
&lt;h3&gt;Detect type&lt;/h3&gt;


&lt;pre class=&quot;brush: c&quot;&gt;
  #define type_str(T) _Generic( (T), int: &quot;int&quot;,\
  long: &quot;long&quot;,\
  default: &quot;Unknown type&quot;)
&lt;/pre&gt;

Now we have define check for 2 types int and long. If there is some type
undefined then choose default type and print &quot;Unknown type&quot;. This is auto
printf example where you can detect type and print its name. But as in page [1]
you can add number values and compare types in simple way.

&lt;pre class=&quot;brush: c&quot;&gt;
  printf(&quot;Type1 %s\n&quot;, type_str(&apos;a&apos;));
  printf(&quot;Type2 %s\n&quot;, type_str(1));
  printf(&quot;Type3 %s\n&quot;, type_str(1l));
  printf(&quot;Type4 %s\n&quot;, type_str(0.0f));
&lt;/pre&gt;

Also is possible to use generic for 2 or more types but then amount
of declaration grows. But it means that now according to params
we can choose best function.

&lt;pre class=&quot;brush: c&quot;&gt;
  #define type_str2(T1,T2) _Generic( (T1),\
  int: _Generic((T2),int:&quot;int int&quot;, default: &quot;int UNK&quot;),\
  default: &quot;UNK UNK&quot; )

  printf(&quot;Double Type 1 %s\n&quot;, type_str2(1,1));
  printf(&quot;Double Type 2 %s\n&quot;, type_str2(1,0.0f));
  printf(&quot;Double Type 3 %s\n&quot;, type_str2(.0f,.0f));
&lt;/pre&gt;

&lt;h3&gt;Check if types is compatible&lt;/h3&gt;

Strange but some types could be invalid if there is const used, like 
&apos;int&apos; and &apos;const int&apos;. 


&lt;pre class=&quot;brush: c&quot;&gt;
  #define is_compatible(x,T) _Generic((x), T:&quot;compatible&quot;,\
  default: &quot;non-compatible&quot;)
&lt;/pre&gt;

Here is defined 2 types and only (int and int) and (const int and const int)
is compatible.

&lt;pre class=&quot;brush: c&quot;&gt;
  int i1;
  const int i2;
  printf(&quot;int       == int,       %s\n&quot;, is_compatible(i1,int));
  printf(&quot;const int == const int, %s\n&quot;, is_compatible(i2,const int));
  printf(&quot;int       == const int, %s\n&quot;, is_compatible(i1,const int));
  printf(&quot;const int == int,       %s\n&quot;, is_compatible(i2,int));
&lt;/pre&gt;



&lt;h2&gt;TESTED&lt;/h2&gt;
gcc-4.9.1
clang-3.4


&lt;h2&gt;FILES&lt;/h2&gt;
ex1.c  -  one argument generic
ex2.c  -  two argument generic
ex3.c  -  check for compatability
</description>
		</item>
		
		<item>
			<title>DWM desktop environment</title>
			<link>http://main.lv/writeup/dwm_desktop_environment.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/dwm_desktop_environment.html</guid>
			<pubDate>[2014, 7, 3] </pubDate>
			<description>
INTRO

DWM is minimalistic tiling manager it contain only few thousand lines of 
code. It main idea is to be simple as possible and usable as possible.
It has only minimal features and if you want to extend it you need to 
edit dwm C source config file or add some patches from dwm project 
web page. You dont need to use mouse to use dwm all actions can be done 
with keyboard.

GOAL

Make dwm fork with some useful minimalistic stuff like dwmstatus 
program that show system statuses. And allow to switch on/off dwm 
patches with linux kernel menuconfig(without menuconfig everything 
works).
Next thing to add is some minimalistic screenlock, screensaver 
and login. At then end there could be minimalistic &quot;suckless&quot; desktop 
environment with all things needed. All parts are as separate 
repositories and can be used independently.

CHANGELOG
[2014.07.10]
dwmstatus
[+]add temperature status
[+]add current CPU usage status
[+]add battery/AC status

[2014.07.03]
dwm branch 6.0
[+] added pango patch
[+] added systemtray patch
[+] added pertag patch
[+] menuconfig support
dwmstatus
[+] added time status
[+] added date status
[+] menuconfig support
</description>
		</item>
		
		<item>
			<title>X11 prototype GUI</title>
			<link>http://main.lv/writeup/x11_prototype_gui.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/x11_prototype_gui.html</guid>
			<pubDate>[2014, 3, 15] </pubDate>
			<description>I allways whanted to write some GUI to try how its is.
This is X11 based GUI based on Xlib it has not &quot;modern&quot; but
in object oriented style. Planning to use it for small
projects. Succesfully compiled it on Linux,OpenBSD,FreeBSD and MacOS.
Should work also on AIX.

&lt;b&gt;COMPILE:&lt;/b&gt;

&lt;pre class=&quot;brush: bash&quot;&gt;
	make
&lt;/pre&gt;

or try:

&lt;pre class=&quot;brush: bash&quot;&gt;
	./compile.sh
&lt;/pre&gt;


&lt;b&gt;TODO:&lt;/b&gt;
fix fleackering
support other compilers not only gcc
add some non-compilable configuration
try to port on SDL,OpenGL,curses
use some cool Wayland stuff
try to make some fancy/modern style
</description>
		</item>
		
		<item>
			<title>kconfig2h utility</title>
			<link>http://main.lv/writeup/kconfig2h_utility.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/kconfig2h_utility.html</guid>
			<pubDate>[2014, 3, 14] </pubDate>
			<description>Kconfig converts linux kernel config files to C headers. Intended to use 
with kconfig utility mconf. Developed to use &quot;make menuconfig&quot; with home 
projects. Using ragel to generate parser of Kconfig file.

&lt;b&gt;USE:&lt;/b&gt;

&lt;pre class=&quot;brush: bash&quot;&gt;
./kconfig .config config.h
&lt;/pre&gt;


&lt;b&gt;TODO:&lt;/b&gt;
if there is need add converters to ruby,c++,python,java


</description>
		</item>
		
		<item>
			<title>Building OpenWRT for RTL8196C</title>
			<link>http://main.lv/writeup/building_openwrt_for_rtl8196c.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/building_openwrt_for_rtl8196c.html</guid>
			<pubDate>[2014, 3, 5] </pubDate>
			<description>
In previous post there wasn&apos;t clearly described how to download
and compile sources for OpenWRT realtek release. Its not official
repository because not yet all things is updated with mainline
OpenWRT and not officially and OpenWRT port. To compile by your 
self there is need to do some basic configuration of sources.


&lt;h2&gt;Getting sources&lt;/h2&gt;
Fits of all need to get sources from git server.
There is some branches in git. But only one of them intended to
be used for non development purposes its &quot;realtek-unstable&quot;


&lt;pre class=&quot;brush: bash&quot;&gt;
git clone git://git.advem.lv/openwrt-realtek.git
cd ./openwrt-realtek/
git branch -a
git checkout realtek-unstable
&lt;/pre&gt;


&lt;h2&gt;Config in menuconfig&lt;/h2&gt;
There is supported only compilation with binutils 2.21.1 and 
gcc-4.6.x-linaro. Now you should setup that options with menuconfig.


&lt;pre class=&quot;brush: bash&quot;&gt;
make menuconfig
&lt;/pre&gt;


This options should be set in &lt;a href=&quot;#i1&quot;&gt;main menu&lt;/a&gt;:

&lt;b&gt;Target System&lt;/b&gt; as (Realtek RTL8xxx) 
&lt;b&gt;Target Profile&lt;/b&gt; as (nprove)   
&lt;b&gt;Advanced configuration options (for developers)&lt;/b&gt; switch on

Now in &lt;b&gt;Advanced configuration options&lt;/b&gt; set &lt;b&gt;Toolchain Options&lt;/b&gt;
and there options for binutils and gcc as in &lt;a href=&quot;#i2&quot;&gt;image&lt;/a&gt;

&lt;b&gt;Binutils Version&lt;/b&gt; as (binutils 2.21.1)
&lt;b&gt;GCC compiler Version&lt;/b&gt; as (gcc 4.6.x with Linaro enhancements)

Last option to switch of is in main menu &lt;b&gt;Network&lt;/b&gt;
&lt;i&gt;firewall3&lt;/i&gt;
&lt;i&gt;odhcp6c&lt;/i&gt;

&lt;h2&gt;Build&lt;/h2&gt;

It could take some time to compile image.

&lt;b&gt;With some compiling output&lt;/b&gt;

&lt;pre class=&quot;brush: bash&quot;&gt;
make V=s
&lt;/pre&gt;


&lt;b&gt;Without extra output&lt;/b&gt;

&lt;pre class=&quot;brush: bash&quot;&gt;
make
&lt;/pre&gt;


&lt;b&gt;Compile in many threads&lt;/b&gt;

&lt;pre class=&quot;brush: bash&quot;&gt;
make -j8
&lt;/pre&gt;




Final image is inside bin/realtek

&lt;h2&gt; UPDATE &lt;/h2&gt; 9 dec 2014
	as main manager that was involved in this &quot;nprove brand&quot; router development 
	based on 8196c/d chip changed job he dont invloved anymore in this project
	as it was. Also domain nprove.in not belong to any who where involved
	in this router development. Probably I can say that this try to port
	realtek fake open source openwrt firmware to mainline openwrt is ended.
	Also chanell on freenode.net/#nprove with main developer also can be 
	considered died. Also all this post now is for historical puropouses. If
	someone interested i could try to get all this 8196c git repo sources and 
	put in archive. Maybe someone will continue development of 8196c chip
	support for mainline openwrt not for fake-relatek-openwrt. 

8 jan 2015
	old repo from git.nprove.in moved to http://git.advem.lv/

30 apr 2015
	updated links 
</description>
		</item>
		
		<item>
			<title>Makefile tips</title>
			<link>http://main.lv/writeup/makefile_tips.html</link>
			<guid isPermaLink="true">http://main.lv/writeup/makefile_tips.html</guid>
			<pubDate>[2014, 1, 5] </pubDate>
			<description>Makefile working tips. Usual simple makefile
looks like this:


&lt;pre class=&quot;brush: bash&quot;&gt;
make:
	gcc main.c -o main
&lt;/pre&gt;


but when your project grows and you use more files it becomes
like this:

&lt;pre class=&quot;brush: bash&quot;&gt;
make:
	gcc -O2 -c file1.c
	gcc -O2 -c file2.c
	gcc -O2 -c file3.c
	gcc -O2 main.c file1.o file2.o file3.o -o main
&lt;/pre&gt;

This is standard growth of file. Its better practice to 
reuse your code, it could applied to your makefile also.

When you have few small project and you want simply copy
makefile and it works.

1. Compiler name
Usually everyone prefer one compiler. And time to time only
check if code compiles with other compilers.

&lt;pre class=&quot;brush: bash&quot;&gt;
CC=gcc
make:
	$(CC) -O2 -c file1.c
	$(CC) -O2 -c file2.c
	$(CC) -O2 -c file3.c
	$(CC) -O2 main.c file1.o file2.o file3.o -o main
&lt;/pre&gt;

2. Project name
Every project have unique name and you also would like
to change it if there is need.

&lt;pre class=&quot;brush: bash&quot;&gt;
PROJECT=project
CC=gcc
make:
	$(CC) -O2 -c file1.c
	$(CC) -O2 -c file2.c
	$(CC) -O2 -c file3.c
	$(CC) -O2 main.c file1.o file2.o file3.o -o $(PROJECT)
&lt;/pre&gt;

3. Compiler flags
Usual problem is when some compiling flags causes problems
and you need to change every single entry in file. 

&lt;pre class=&quot;brush: bash&quot;&gt;
PROJECT=project
CC=gcc
CFLAGS=-O2
make:
	$(CC) $(CFLAGS) -c file1.c
	$(CC) $(CFLAGS) -c file2.c
	$(CC) $(CFLAGS) -c file3.c
	$(CC) $(CFLAGS) main.c file1.o file2.o file3.o -o $(PROJECT)
&lt;/pre&gt;

This 3 variables reduce how number of places that you need
to edit if something changes.

Next thing is to fix problem when you need to add or remove
file from project and after that you have manually to edit
at least 2 lined in makefile.

4. Use multiple files

One of they ways how to reduce number of files edited is to add
new variable where all files is listed:

&lt;pre class=&quot;brush: bash&quot;&gt;
PROJECT=project
CC=gcc
CFLAGS=-O2
SOURCES=file1.c file2.c file3.c
OBJECTS=$(SOURCES:.c=.o)

all: $(OBJECTS) $(PROJECT)

$(PROJECT): $(SOURCES) main.c
	$(CC) $(OBJECTS) $(CFLAGS) main.c -o $(PROJECT)

%.o: %.c
	$(CC) $(CFLAGS) -c $&lt;
&lt;/pre&gt;

Here was added file auto-matching for *.c files to make them *.o

5. Auto matching C files

Last thing to add is auto match all *.c in directory.

&lt;pre class=&quot;brush: bash&quot;&gt;
PROJECT=project
CC=gcc
CFLAGS=-O2
SOURCES=$(wildcard *.c)
OBJECTS=$(SOURCES:.c=.o)

all: $(OBJECTS) $(PROJECT)

$(PROJECT): $(SOURCES) main.c
	$(CC) $(OBJECTS) $(CFLAGS) -o $(PROJECT)

%.o: %.c
	$(CC) $(CFLAGS) -c $&lt;
&lt;/pre&gt;

Now project makefile can be easily copied and with
changing only one variable value everything should be OK
To run any makefile:

&lt;pre class=&quot;brush: bash&quot;&gt;
make -f makefile_name.mk
&lt;/pre&gt;

</description>
		</item>
		
	</channel>
</rss>